# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
monitor = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
dbname   = 'sam_ranks.db'
data     = func.getDB(dbname)
temp     = {'PReset':True,'wipe':False}
session  = {}
basename = 'rankstats'
tag      = '#yellowRANKSTATS'
adverts  = ['INFO_SESSION','INFO_RANK','INFO_TOP','INFO_RESET']
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.SayCMD('!rank', rankCMD)
	func.SayCMD('rank', rankCMD)
	func.SayCMD('!session', sessionCMD)
	func.SayCMD('session', sessionCMD)
	func.SayCMD('!top', topCMD)
	func.SayCMD('top', topCMD)
	func.SayCMD('!resetrank', resetPlayerCMD)
	func.ServerCMD('sam_rankstats_allow_player_reset', allowPlayerResetCMD)
	func.ServerCMD('sam_rankstats_reset_db', resetDB)

	lib = {'sam_rankstats_allow_player_reset':{'value':1,'description':'If 1 allows players to reset theyr rank.'}}
	monitor.cfg(basename, lib)

	# ADD ADVERT MESSAGE
	for x in adverts: monitor.addmsg('rankstats_%s' % x) 

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unSayCMD('!rank')
	func.unSayCMD('rank')
	func.unSayCMD('!session')
	func.unSayCMD('session')
	func.unSayCMD('!top')
	func.unSayCMD('top')
	func.unSayCMD('!resetrank')
	func.unServerCMD('sam_rankstats_allow_player_reset')
	func.unServerCMD('sam_rankstats_reset_db')

	# POPUPS
	func.popupDelete('RANK_PAGE')
	func.popupDelete('SESSION_PAGE')
	func.popupDelete('TOP_LIST')

	# REMOVE ADVERT MESSAGE
	for x in adverts: monitor.removemsg('rankstats_%s' % x)

	# SAVE DATABASE
	if temp['wipe']: func.saveDB(dbname, {})
	else: func.saveDB(dbname, data)

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def register(ev):
	if ev['userid']:
		victim    = playerlib.getPlayer(ev['userid'])
		victim_id = victim.steamid
		if victim_id != 'BOT' or func.dev:
			if not victim_id in data: data[victim_id] = {'name':victim.name,'k':0,'d':0,'hs':0,'kdr':0.00}
			if not int(victim) in session: session[int(victim)] = {'k':0,'d':0,'hs':0,'kdr':0.00}
			data[victim_id]['d']   += 1
			data[victim_id]['kdr'] = float(data[victim_id]['k']) / data[victim_id]['d']	
			session[int(victim)]['d']   += 1
			session[int(victim)]['kdr'] = float(session[int(victim)]['k']) / session[int(victim)]['d']
		if ev['attacker']:
			attacker    = playerlib.getPlayer(ev['attacker'])
			attacker_id = attacker.steamid
			if attacker_id != 'BOT' or func.dev:
				if not attacker_id in data: data[attacker_id] = {'name':attacker.name,'k':0,'d':0,'hs':0,'kdr':0.00}
				if not int(attacker) in session: session[int(attacker)] = {'k':0,'d':0,'hs':0,'kdr':0.00}
				if victim.teamid != attacker.teamid:
					if not victim_id == 'BOT' or func.dev:
						data[attacker_id]['k']      += 1
						session[int(attacker)]['k'] += 1
						if ev['headshot'] == '1':
							data[attacker_id]['hs']      += 1
							session[int(attacker)]['hs'] += 1
				else:
					data[attacker_id]['k'] -= 1
					session[int(attacker)]['k'] -= 1
				if data[attacker_id]['d'] and data[attacker_id]['k']:
					data[attacker_id]['kdr'] = float(data[attacker_id]['k']) / data[attacker_id]['d']
				if session[int(attacker)]['d'] and session[int(attacker)]['k']:
					session[int(attacker)]['kdr'] = float(session[int(attacker)]['k']) / session[int(attacker)]['d']


# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getList(s=False):
	if len(list(data)):
		if s: return enumerate(sorted(data, key=lambda steamid: data[steamid]['k'], reverse=True)[:10])
		else: return sorted(data, key=lambda steamid: data[steamid]['k'], reverse=True)[:10]
	else: return []

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def rankCMD(ID, ARGS):
	steamid = es.getplayersteamid(ID)
	if not steamid in data: data[steamid] = {'name':es.getplayername(ID),'k':0,'d':0,'hs':0,'kdr':0.00}
	ply   = data[steamid]
	popup = func.simplemenu('RANK_PAGE',None,5)
	popup.addline('%s RANK STATS' % ply['name'])
	popup.addline(' ')
	top = getList(True)
	if top:
		for a,b in top:
			if b == steamid: rank = a+1
		if rank: popup.addline('> RANKED %s OF %s PLAYERS' % (rank,len(getList())))
	popup.addline('> KILLS: %i' % ply['k'])
	popup.addline('> DEATHS: %i' % ply['d'])
	popup.addline('> KDR: %.2f' % ply['kdr'])
	popup.addline('> HS: %i (%i%%)' % (ply['hs'],func.percentage(ply['hs'],ply['k'])))
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def sessionCMD(ID, ARGS):
	if not ID in session: session[ID] = {'k':0,'d':0,'hs':0,'kdr':0.00}
	ply   = session[ID]
	popup = func.simplemenu('SESSION_PAGE',None,5)
	popup.addline('%s SESSION STATS' % es.getplayername(ID))
	popup.addline(' ')
	popup.addline('> KILLS: %i' % ply['k'])
	popup.addline('> DEATHS: %i' % ply['d'])
	popup.addline('> KDR: %.2f' % ply['kdr'])
	popup.addline('> HEADSHOTS: %i (%i%%)' % (ply['hs'],func.percentage(ply['hs'],ply['k'])))
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def topCMD(ID, ARGS):
	top = getList()
	if top:
		popup = func.easymenu(('TOP_LIST', top_Choice))
		popup.settitle(func.header(monitor.get(basename, 'name')))
		popup.setdescription(' # RANKING LIST (%s PLAYERS)' % len(getList()))
		for steamid in top:
			if steamid in data:
				ply = data[steamid]
				popup.addoption(steamid, '%s: %s Kills (KDR: %.2f)' % (ply['name'],ply['k'],ply['kdr']))
		popup.send(ID)
	else: func.hudhint(ID, func.langAddon(basename, 'NO_RANKED'), tag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def top_Choice(ID, CHOICE, POPUP): pass

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def resetPlayerCMD(ID, ARGS):
	if temp['PReset']:
		steamid = es.getplayersteamid(ID)
		if steamid in data: del data[steamid]
		func.tell(ID, func.langAddon(basename, 'RANK_RESET'), tag)
		rankCMD(ID, [])
	else: func.tell(ID, func.langAddon(basename, 'CANT_RESET'), tag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def resetDB(ARGS):
	if os.path.isfile(func.dbPath+dbname): os.remove(func.dbPath+dbname)
	temp['wipe'] = True
	func.tell('#all', func.langAddon(basename, 'DB_RESET'), tag)
	es.reload('sam/addons/rankstats')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def allowPlayerResetCMD(ARGS):
	if ARGS:
		try:
			args = int(' '.join(ARGS))
			if args in (1,0): temp['PReset'] = bool(args)
		except: pass

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_death(ev): register(ev)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def es_map_start(ev): func.saveDB(dbname, data)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_activate(ev):
	steamid = es.getplayersteamid(ev['userid'])
	if steamid in data: data[steamid]['name'] = es.getplayername(ev['userid'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_disconnect(ev):
	if int(ev['userid']) in session: del session[int(ev['userid'])]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_changename(ev):
	steamid = es.getplayersteamid(ev['userid'])
	if steamid in data: data[steamid]['name'] = es.getplayername(ev['userid'])

# =============================================================================== #