# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, random, popuplib, usermsg
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
core     = es.import_addon('sam/core')
admins   = es.import_addon('sam/core/admins')
pcontrol = es.import_addon('sam/core/pcontrol')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
ids   = {1:'spec',2:'t',3:'ct'}
CACHE = {}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.SayCMD('!spec', specCMD)
	func.SayCMD('!teams', teamsCMD)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unSayCMD('!spec')
	func.unSayCMD('!teams')

	# POPUPS
	func.popupDelete('TEAMS_MAIN')
	func.popupDelete('TEAMS_MOVE_SPEC')
	func.popupDelete('TEAMS_MOVE_TEAM')
	func.popupDelete('TEAMS_OPPOSITE')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	popup = func.simplemenu('TEAMS_MAIN','PCONTROL_MAIN')
	popup.addline(func.header(func.langPcontrol('TEAMS_MANAGER')))
	popup.addline(func.line)
	popup.addline('->1. %s' % func.stripColors(func.langCommon('SPEC')))
	popup.addline('->2. %s' % func.langPcontrol('MOVE_TO_TEAM', {'team':func.stripColors(func.langCommon('T'))}))
	popup.addline('->3. %s' % func.langPcontrol('MOVE_TO_TEAM', {'team':func.stripColors(func.langCommon('CT'))}))
	popup.addline('->4. %s' % func.langPcontrol('MOVE_OPPOSITE_TEAM'))
	popup.addline('->5. %s' % func.langPcontrol('MOVE_SWAP'))
	popup.addline('->6. %s' % func.langPcontrol('MOVE_SCRAMBLE'))
	popup.addline('->7. %s' % func.langPcontrol('MOVE_ALLSPEC'))
	popup.addline(' ')
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.select(1, move_spec)
	popup.select(2, move_teams)
	popup.select(3, move_teams)
	popup.select(4, opposite_teams)
	popup.select(5, swap_teams)
	popup.select(6, scramble_teams)
	popup.select(7, all_spec)
	popup = popuplib.find('TEAMS_MAIN')
	if SEND: popup.send(ID)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def move_spec(ID, OPTION, POPUP):
	teams = playerlib.getPlayerList('#ct')+playerlib.getPlayerList('#t')
	if len(teams):
		popup = func.easymenu(('TEAMS_MOVE_SPEC', move_spec_SELECT),'TEAMS_MAIN')
		popup.settitle(func.header(func.langPcontrol('TEAMS_MANAGER')))
		popup.setdescription(' # %s' % func.langCommon('CHOOSE_PLAYER'))
		for x in teams: popup.addoption(x, '%s [%s]' % (x.name,ids[x.teamid].upper()))
		popup.send(ID)
	else:
		func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
		page(ID)

# ------------------------------------------------------------------------------- #
def move_spec_SELECT(ID, TARGET, POPUP):
	change_team(TARGET, 1)
	func.hudhint(TARGET, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon('SPEC')}),func.teamstag)
	func.tell('#all', func.langPcontrol('TARGET_MOVED',{'target':TARGET.name,'team':func.langCommon('SPEC')}), func.teamstag)
	move_spec(ID, None, None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def move_teams(ID, TEAM, POPUP):
	teams = playerlib.getPlayerList('#spec')+playerlib.getPlayerList('#%s'%ids[5-TEAM])
	if len(teams):
		CACHE[ID] = TEAM
		popup = func.easymenu(('TEAMS_MOVE_TEAM', move_teams_SELECT),'TEAMS_MAIN')
		popup.settitle(func.header(func.langPcontrol('TEAMS_MANAGER')))
		popup.setdescription(' # %s' % func.langCommon('CHOOSE_PLAYER'))
		for x in teams: popup.addoption(x, '%s [%s]' % (x.name,ids[x.teamid].upper()))
		popup.send(ID)
	else:
		func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
		page(ID)

# ------------------------------------------------------------------------------- #
def move_teams_SELECT(ID, TARGET, POPUP):
	change_team(TARGET, CACHE[ID])
	func.hudhint(TARGET, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon(ids[CACHE[ID]].upper())}),func.teamstag)
	func.tell('#all', func.langPcontrol('TARGET_MOVED',{'target':TARGET.name,'team':func.langCommon(ids[CACHE[ID]].upper())}), func.teamstag)
	move_teams(ID, CACHE[ID], None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def opposite_teams(ID, OPTION, POPUP):
	teams = playerlib.getPlayerList('#ct')+playerlib.getPlayerList('#t')
	if len(teams):
		popup = func.easymenu(('TEAMS_OPPOSITE', opposite_teams_SELECT),'TEAMS_MAIN')
		popup.settitle(func.header(func.langPcontrol('TEAMS_MANAGER')))
		popup.setdescription(' # %s' % func.langCommon('CHOOSE_PLAYER'))
		for x in teams: popup.addoption(x, '%s [%s]' % (x.name,ids[x.teamid].upper()))
		popup.send(ID)
	else:
		func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
		page(ID)

# ------------------------------------------------------------------------------- #
def opposite_teams_SELECT(ID, TARGET, POPUP):
	change_team(TARGET, TARGET.teamid - 5)
	func.hudhint(TARGET, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon(ids[team].upper())}),func.teamstag)
	func.tell('#all', func.langPcontrol('TARGET_MOVED',{'target':TARGET.name,'team':func.langCommon(ids[team].upper())}), func.teamstag)
	opposite_teams(ID, None, None)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def swap_teams(ID, OPTION, POPUP):
	teams = playerlib.getPlayerList('#ct')+playerlib.getPlayerList('#t')
	if len(teams):
		for x in teams:
			if not x.steamid == 'BOT':
				if x.teamid == 2: change_team(x, 3)
				if x.teamid == 3: change_team(x, 2)
		es.server.insertcmd('bot_kick')
		es.server.insertcmd('bot_quota %s' % (int(es.ServerVar('bot_quota'))))
		func.tell('#all', func.langPcontrol('TEAMS_SWAPED'),func.teamstag)
	else:
		if ID: func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
	if ID: page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def scramble_teams(ID, OPTION, POPUP):
	es.server.insertcmd('bot_kick')
	humans = playerlib.getPlayerList('#human')
	teams = [[],[]]
	div   = int(len(humans) / 2)
	while len(teams[0]) <= div:
		for x in humans:
			teams[0].append(x)
			humans.remove(x)
		else:
			for x in humans: teams[1].append(x)
	a = random.choice([3,2])
	for x in teams[0]: change_team(x, a)
	if a == 2: a = 3
	for x in teams[1]: change_team(x, a)
	es.server.insertcmd('bot_quota %s' % (int(es.ServerVar('bot_quota'))))
	func.tell(ID, 'Scramble Teams', func.teamstag)
	page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def all_spec(ID, OPTION, POPUP):
	teams = playerlib.getPlayerList('#ct')+playerlib.getPlayerList('#t')
	if len(teams):
		for x in teams: change_team(x, 1)
		func.tell('#all', func.langPcontrol('ALLTOSPEC'),func.teamstag)
	else: func.hudhint(ID, func.langCommon('NO_TEAMS'),func.teamstag)
	page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def change_team(TARGET, NEWTEAM):
	if NEWTEAM == 1:
		es.changeteam(TARGET, 1)
		return
	elif es.getplayerteam(TARGET) > 1: es.changeteam(TARGET, 1)
	es.changeteam(TARGET, NEWTEAM)
	if NEWTEAM == 2:
		es.setplayerprop(TARGET, 'CCSPlayer.m_iClass', random.randint(1, 4))
		usermsg.showVGUIPanel(TARGET, 'class_ter', False, {})
	elif NEWTEAM == 3:
		es.setplayerprop(TARGET, 'CCSPlayer.m_iClass', random.randint(5, 8))
		usermsg.showVGUIPanel(TARGET, 'class_ct', False, {})

# =============================================================================== #
# === <<<  CMD BLOCKS <    ====================================================== #
# =============================================================================== #
def specCMD(ID, ARGS):
	if not es.getplayerteam(ID) == 1:
		es.changeteam(ID, 1)
		func.hudhint(ID, func.langPcontrol('TELL_TARGET_MOVED',{'team':func.langCommon('SPEC')}),func.teamstag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def teamsCMD(ID, ARGS):
	if admins.can(ID, 'Manage Teams'): page(ID)

# =============================================================================== #